"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addImplicitRule = exports.modify = exports.get = exports.set = void 0;
const contracts_js_1 = require("./contracts.js");
let config = {
    wildcardIterations: 1000,
    wildcardSeperator: '.',
    lang: contracts_js_1.Langs.en_US,
    implicitRules: [
        "required",
        "requiredIf",
        "requiredNotIf",
        "requiredWith",
        "requiredWithout",
        "accepted",
        "sometimes",
        "nullable",
    ],
};
function set(customConfig) {
    config = Object.assign(Object.assign({}, config), customConfig);
}
exports.set = set;
function get(key, defaultValue = null) {
    if (key) {
        return config[key] || defaultValue;
    }
    return config;
}
exports.get = get;
function modify(key, value) {
    config[key] = value;
}
exports.modify = modify;
function addImplicitRule(ruleName) {
    var _a;
    (_a = config.implicitRules) === null || _a === void 0 ? void 0 : _a.push(ruleName);
}
exports.addImplicitRule = addImplicitRule;
//# sourceMappingURL=config.js.map