"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) __createBinding(exports, m, p);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.bailable = exports.koa = exports.extend = exports.addImplicitRule = exports.lang = exports.useDateAdapter = exports.configure = exports.Rules = exports.Validator = void 0;
__exportStar(require("./contracts.js"), exports);
exports.Messages = __importStar(require("./messages/index.js"));
const Rules = __importStar(require("./rules/index.js"));
exports.Rules = Rules;
const validator_js_1 = require("./validator.js");
Object.defineProperty(exports, "Validator", { enumerable: true, get: function () { return validator_js_1.Validator; } });
var index_js_1 = require("./date/index.js");
Object.defineProperty(exports, "MomentAdapter", { enumerable: true, get: function () { return index_js_1.MomentAdapter; } });
Object.defineProperty(exports, "DateFnsAdapter", { enumerable: true, get: function () { return index_js_1.DateFnsAdapter; } });
const config = __importStar(require("./config.js"));
function configure(customConf) {
    config.set(customConf);
}
exports.configure = configure;
function useDateAdapter(dateAdapter) {
    config.modify('dateAdapter', dateAdapter);
}
exports.useDateAdapter = useDateAdapter;
function lang(lang) {
    config.modify('lang', lang);
}
exports.lang = lang;
function addImplicitRule(ruleName) {
    config.addImplicitRule(ruleName);
}
exports.addImplicitRule = addImplicitRule;
function extend(ruleName, ruleFunc) {
    // @ts-ignore
    Rules[ruleName] = ruleFunc;
}
exports.extend = extend;
/* istanbul ignore next */
function koa() {
    return async (ctx, next) => {
        // @ts-ignore
        ctx.validationErrors = function validationErrors(errors) {
            return {
                body: {
                    message: 'The given data is invalid.',
                    errors,
                },
            };
        };
        ctx.validate = async function validate(rulesArray, inputs, useMessages) {
            const v = new validator_js_1.Validator(inputs || Object.assign(Object.assign({}, this.request.body), this.request.files), rulesArray || {}, useMessages || {});
            if (!(await v.validate())) {
                this.throw(422, this.validationErrors(v.errors));
            }
            return v;
        };
        ctx.validator = (inputs, rulesArray, useMessages) => new validator_js_1.Validator(inputs, rulesArray, useMessages);
        try {
            await next();
        }
        catch (err) {
            if (err.status && err.status === 422) {
                ctx.type = 'json';
                ctx.status = 422;
                ctx.body = err.body;
                return;
            }
            throw err;
        }
    };
}
exports.koa = koa;
/**
 * enable/disable multiple errors output
 * @param {boolean} sure
 */
function bailable(sure) {
    validator_js_1.Validator.bailable(sure);
}
exports.bailable = bailable;
//# sourceMappingURL=index.js.map