"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mime = void 0;
const mimeTypes = __importStar(require("mime-types"));
const file_type_1 = __importDefault(require("file-type"));
const { fromBuffer } = file_type_1.default;
const read_chunk_1 = __importDefault(require("read-chunk"));
function mime(args, trust = false) {
    return {
        name: "mime",
        handler: async (value) => {
            let mtype;
            if (trust) {
                mtype = value.mime || value.type;
            }
            else if (value instanceof Buffer) {
                try {
                    const fileType = await fromBuffer(value);
                    if (fileType) {
                        mtype = fileType.mime;
                    }
                }
                catch (e) {
                    /* istanbul ignore next */
                    console.error(e);
                }
            }
            // should uncomment if found any practile use
            // else if (value.buffer && value.buffer instanceof Buffer) {
            //   try {
            //     const fileType = await fromBuffer(value.buffer);
            //     if (fileType) {
            //       mtype = fileType.mime;
            //     }
            //   } catch (e) {
            //     /* istanbul ignore next */
            //     console.error(e);
            //   }
            // } 
            else if (typeof value === 'string') {
                try {
                    const buffer = await read_chunk_1.default(value, 0, 4100);
                    const fileType = await fromBuffer(buffer);
                    if (fileType) {
                        mtype = fileType.mime;
                    }
                }
                catch (e) {
                    /* istanbul ignore next */
                    console.error(e);
                }
            }
            else if (value.path && typeof value.path === 'string') {
                try {
                    const buffer = await read_chunk_1.default(value.path, 0, 4100);
                    const fileType = await fromBuffer(buffer);
                    if (fileType) {
                        mtype = fileType.mime;
                    }
                }
                catch (e) {
                    /* istanbul ignore next */
                    console.error(e);
                }
            }
            // else {
            //   throw new Error('MIME rule only accepts Buffer,file path or type/mime property in file object.');
            // }
            for (let i = 0; i < args.length; ++i) {
                if (mimeTypes.lookup(args[i]) === mtype || args[i] === mtype) {
                    return true;
                }
            }
            return false;
        },
    };
}
exports.mime = mime;
//# sourceMappingURL=mime.rule.js.map